/* bindump.c v1.0 2016/11/21
 * Program which prints binary data bitwise in  8-Bit chunks with 4 Bytes per line
 *
 * (C) 2017 Copyright beroNet GmbH
 * Author: Christian Richter
 * Contact: info@beronet.com
 *
 * This program is licensed by beroNet and may only be used in the PoC for the project: 
 * 'IP22' - Media Gateway ( or higher IPxx Versions)
 *
 */

#include <stdio.h>

void print_bits(char c) {
	int i;

	for (i=7; i>=0; i--) 
		printf("%d", (1<<i)&c?1:0);

	printf(" ");
}

int main()
{
	unsigned char buf[4];
	int l,i;
	while (1) {
		l=read(0, buf, sizeof(buf));

		if (l<=0) break;	

		for(i=0; i<l; i++) 	
			printf("%02x ", buf[i] & 0xff);
		printf(": ");
		for(i=0; i<l; i++) 	
			print_bits(buf[i] & 0xff);
		printf("\n");
		
	}
}

